#include <pwd.h>
#include <time.h>
#include <errno.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "mic.h"
#include "config.h"
#include "vyroci.h"

#define	debug	dummy

void Install()
{
	FILE	*f,*f2;
	char	buf[200],buf2[100];
	int	valid,n;
	struct stat	st;
	
	
	printf("\
Vitam vas v instalaci programu 'vyroci %s' pro Unix.

Instalacni program vam v mnoha pripadech nabidne 
predpokladanou odpoved v hranatych zavorkach. 
Pokud na takovou otazku odpovite pouze <Enter>, 
tak se nabidnuta odpoved pouzije. Pokud napisete 
jinou odpoved, a ta bude programu vyhovovat, pouzije ji.
Napriklad:

Jeste vas to bavi cist? [Ano]: <Enter>
 -program bude polichocen a nabidne Vam dalsi otazky.

Jeste vas to bavi cist? [Ano]: ne<Enter>
 -program se urazi a skonci

Jeste vas to bavi cist? [Ano]: 21<Enter>
 -program si o vas sice pomysli, ze cist asi neumite,
  ale zkusi se vas zeptat jeste jednou

Pokud bude v zavorce uvedeno vice odpovedi, 
program od vas ocekava jednu z nich (napr: [Ano/Ne]).
Pokud odpovite <Enter>, tak pouzije prvni z nich.

Takze se do toho pustime <Enter>:",VERSION);
	gets(buf);
	
	printf("\n----------
Vyberte si adresar, ktery chcete pouzit pro ulozeni
konfiguracniho souboru a pravdepodobne take databazi.
(vsechny dalsi soubory zadavejte relativne k tomuto adresari)

V teto verzi nema smysl vybirat jiny adresar, 
nez ten, ktery vam bude nabidnut, protoze program s jinym 
stejne neumi pracovat :-)) [takze doporucuji <Enter>]\n
");

	printf("Jaky adresar chcete pouzivat? [%s/%s]: ",getpwuid(getuid())->pw_dir,SUBDIR_NM);
	gets(buf);
	n=strlen(buf);
	while(buf[--n]==' ')buf[n]=0;
	
	if(buf[0]==0)
		sprintf(cfg.pdir,"%s/%s",getpwuid(getuid())->pw_dir,SUBDIR_NM);
	else
		sprintf(cfg.pdir,buf);
	
	if(mkdir(cfg.pdir,0700)<0)
		switch(errno)
		{
			case	EEXIST:	stat(cfg.pdir,&st);
								if(!S_ISDIR(st.st_mode))
									failprog(1,"chyba: %s existuje, ale neni to adresar...\n",cfg.pdir);
								if(st.st_uid != getuid())
									failprog(1,"chyba: %s existuje, ale nejste jeho vlastnik...\n",cfg.pdir);
								if((st.st_mode & ~S_IRWXU) != S_IRWXU)
									if(chmod(cfg.pdir,0700)<0)
										failprog(1,"chyba: %s existuje, ale ma nevhodna pristupova prava... Pokus o zmenu selhal (%s)\n",errstr(errno));
								break;
								
			default:	failprog(1,"chyba: nemohu vytvorit %s (%s)\n",cfg.pdir,errstr(errno));					
		}
	
	if(chdir(cfg.pdir)<0)
		failprog(1,"chyba: nemohu zmenit aktualni adresar na %s (%s)\n",cfg.pdir,errstr(errno));
	
	printf("\n----------
Nyni si sice muzete vybrat jmeno souboru pro ulozeni konfigurace, 
ale pokud si zvolite neco jineho, nez vam bude nabidnuto, 
tak akorat ztracite cas ;-) [viz minula volba]\n
");

	printf("Kam chcete ulozit konfiguraci? [%s]: ",CONFIG_NM);
	gets(buf);
	n=strlen(buf);
	while(buf[--n]==' ')buf[n]=0;
	
	if(buf[0]==0)
		sprintf(buf,"%s",CONFIG_NM);
	
	if((f=fopen(buf,"w"))==NULL)
		failprog(1,"chyba: nemohu zalozit soubor %s/%s (%s)\n",cfg.pdir,buf,errstr(errno));
	
	fprintf(f,"[vyroci]\n");
	fprintf(f,"Version  = 1\n");
	
	printf("\n----------
Nasledujici volbou urcite jmeno souboru, 
ktery bude pouzit pro funkci once-a-day.
Nyni si konecne muzete libovolne vybrat :-)
(pokud na manipulaci se souborem nemate dostatek prav, 
dozvite se to az pri pouziti fce OaD)\n
");

	printf("Soubor pro funkci OaD? [%s]: ",ODFILE_NM);
	gets(buf);
	n=strlen(buf);
	while(buf[--n]==' ')buf[n]=0;
	
	if(buf[0]==0)
		sprintf(buf,ODFILE_NM);
	
	fprintf(f,"OnceAday = %s\n",buf);
	
/* Nameday */
	printf("\n----------
Ted vyberte soubor, ktery obsahuje seznam vsech svatku.
Vas system mozna obsahuje soubory s ruznym kodovanim cestiny,
pripadne s ruznymi kalendari. Poradte se se spravcem, 
nebo pouzijte metodu pokus-omyl\n
");

	valid=0;
	do {
		printf("Databaze svatku [%s/%s.cz.us-ascii]: ",SYSDIR_NM,NAMEDAY_NM);
		gets(buf);
		n=strlen(buf);
		while(buf[--n]==' ')buf[n]=0;
		
		if(buf[0]==0)
			sprintf(buf,"%s/%s.cz.us-ascii",SYSDIR_NM,NAMEDAY_NM);
		
		if((f2=fopen(buf,"r"))==NULL)
		{
			printf("varovani: Soubor %s nelze otevrit.\nChcete ho presto pouzit? [N/a] ",buf);
			fgets(buf2,100,stdin);
			switch(buf2[0])
			{
				case	'A':
				case	'a':	valid=1; break;
				default:		valid=0;
			}
		}
		else
		{
			fclose(f2);
			valid=1;
		}
	} while(!valid);
	
	fprintf(f,"\nNameday  = %s\n",buf);
		
/* NDflag */
	printf("\n----------
Nyni uvedte, zda si prejete implicitne vypisovat seznam 
nekolika nasledujicich svatku. 
Tuto volbu muzete zmenit vhodnym parametrem pri spousteni.\n
");
	
	valid=0;
	do {
		printf("Pokazde ukazovat seznam nasledujicich svatku? [A/n]: ");
		gets(buf);
		
		switch(buf[0])
		{
			case	0:
			case	'A':
			case	'a':
			case	'Y':
			case	'y':	fprintf(f,"NDflag   = Yes\n");
							cfg.ndflag=1;
							valid=1;
							break;
			case	'N':
			case	'n':	fprintf(f,"NDflag   = No\n");
							cfg.ndflag=0;
							valid=1;
							break;
			default:		valid=0;
		}
	} while (!valid);

/* NDdays */	
if(cfg.ndflag)
{
	printf("\n----------	
Prave mate moznost urcit, kolik nadchazejicich svatku chcete ukazat.
Do tohoto cisla se nezapocitava den spusteni.\n
");
	
	valid=0;
	do {
		printf("Kolik svatku chcete ukazat? [%d]: ",NDDAYS_VAL);
		gets(buf);
		
		if(buf[0]==0)
		{
			fprintf(f,"NDdays   = %d\n",NDDAYS_VAL);
			valid=1;
		}
		else
			if(sscanf(buf,"%ud",&n)==1)
			{
				valid=1;
				fprintf(f,"NDdays   = %d\n",n);
			}
	} while (!valid);
}
else
	fprintf(f,"# NDdays = %d\n",NDDAYS_VAL);

/* Annual */
	printf("\n----------
Zadejte jmeno souboru, do ktereho se bude ukladat vami 
vytvareny seznam svatku a narozenin. \n
");

	valid=0;
	do {
		printf("Databaze narozenin & svatku [%s]: ",ANNUAL_NM);
		gets(buf);
		n=strlen(buf);
		while(buf[--n]==' ')buf[n]=0;
		
		if(buf[0]==0)
			sprintf(buf,"%s",ANNUAL_NM);
		
		if((f2=fopen(buf,"w"))==NULL)
		{
			printf("varovani: Soubor %s nelze vytvorit.\nChcete ho presto pouzit? [N/a] ",buf);
			fgets(buf2,100,stdin);
			switch(buf2[0])
			{
				case	'A':
				case	'a':	valid=1; break;
				default:		valid=0;
			}
		}
		else
		{
			fprintf(f2,"\
# polozky v tomto souboru jsou ve tvaru:
# Jmeno Prijmeni = dd.mm.yyyy /a : dd.mm. /b
# kde dd.mm.yyyy je datum narozenin (den,mesic,rok)
#     dd.mm. je datum svatku
# a polozky  /a, /b udavaji kolik dni predem chcete byt varovani\n
");
			fclose(f2);
			valid=1;
		}
	} while(!valid);
	
	fprintf(f,"\nAnnual   = %s\n",buf);

/* ANflag */
	printf("\n----------
Nyni uvedte, zda si prejete prohledavat databazi 'annual'
Tuto volbu muzete zmenit vhodnym parametrem pri spousteni.\n
");
	
	valid=0;
	do {
		printf("Pokazde ukazovat seznam nadchazejicich vyroci? [A/n]: ");
		gets(buf);
		
		switch(buf[0])
		{
			case	0:
			case	'A':
			case	'a':
			case	'Y':
			case	'y':	fprintf(f,"ANflag   = Yes\n");
							cfg.anflag=1;
							valid=1;
							break;
			case	'N':
			case	'n':	fprintf(f,"ANflag   = No\n");
							cfg.anflag=0;
							valid=1;
							break;
			default:		valid=0;
		}
	} while (!valid);
	
if(cfg.anflag)
{
	printf("\n----------	
Ted zadejte, kolik dni predem chcete byt upozorneni v pripade, 
ze zaznam v databazi tento udaj neobsahuje.\n
");
	
	valid=0;
	do {
		printf("Kolik dni predem chcete byt upozorneni? [%d]: ",ANDAYS_VAL);
		gets(buf);
		
		if(buf[0]==0)
		{
			fprintf(f,"ANdays   = %d\n",ANDAYS_VAL);
			valid=1;
		}
		else
			if(sscanf(buf,"%ud",&n)==1)
			{
				valid=1;
				fprintf(f,"ANdays   = %d\n",n);
			}
	} while (!valid);
}
else
	fprintf(f,"# ANdays = %d\n",ANDAYS_VAL);

/* Onetime */
	printf("\n----------
Zadejte jmeno souboru, do ktereho budete ukladat seznam 
dulezitych jednorazovych udalosti na ktere by nebylo rando zapomenout\n
");

	valid=0;
	do {
		printf("Databaze jednorazovych udalosti [%s]: ",ONETIME_NM);
		gets(buf);
		n=strlen(buf);
		while(buf[--n]==' ')buf[n]=0;
		
		if(buf[0]==0)
			sprintf(buf,"%s",ONETIME_NM);
		
		if((f2=fopen(buf,"w"))==NULL)
		{
			printf("varovani: Soubor %s nelze vytvorit.\nChcete ho presto pouzit? [N/a] ",buf);
			fgets(buf2,100,stdin);
			switch(buf2[0])
			{
				case	'A':
				case	'a':	valid=1; break;
				default:		valid=0;
			}
		}
		else
		{
			fprintf(f2,"\
# polozky v tomto souboru jsou ve tvaru:
# Dulezita udalost = dd.mm.yyyy /a
# kde dd.mm.yyyy je datum dulezite udalosti (den,mesic,rok)
# a polozka /a udava kolik dni predem chcete byt varovani\n
");
			fclose(f2);
			valid=1;
		}
	} while(!valid);
	
	fprintf(f,"\nOnetime   = %s\n",buf);

/* OTflag */
	printf("\n----------
Nyni uvedte, zda si prejete prohledavat databazi 'onetime'
Tuto volbu muzete zmenit vhodnym parametrem pri spousteni.\n
");
	
	valid=0;
	do {
		printf("Pokazde ukazovat seznam nadchazejicich dulezitych udalosti? [A/n]: ");
		gets(buf);
		
		switch(buf[0])
		{
			case	0:
			case	'A':
			case	'a':
			case	'Y':
			case	'y':	fprintf(f,"OTflag   = Yes\n");
							cfg.otflag=1;
							valid=1;
							break;
			case	'N':
			case	'n':	fprintf(f,"OTflag   = No\n");
							cfg.otflag=0;
							valid=1;
							break;
			default:		valid=0;
		}
	} while (!valid);
	
if(cfg.otflag)
{
	printf("\n----------	
Ted zadejte, kolik dni predem chcete byt upozorneni v pripade, 
ze zaznam v databazi tento udaj neobsahuje.\n
");
	
	valid=0;
	do {
		printf("Kolik dni predem chcete byt upozorneni? [%d]: ",OTDAYS_VAL);
		gets(buf);
		
		if(buf[0]==0)
		{
			fprintf(f,"OTdays   = %d\n",OTDAYS_VAL);
			valid=1;
		}
		else
			if(sscanf(buf,"%ud",&n)==1)
			{
				valid=1;
				fprintf(f,"OTdays   = %d\n",n);
			}
	} while (!valid);
}
else
	fprintf(f,"# OTdays = %d\n",OTDAYS_VAL);

	fclose(f);
	
	printf("\n----------
Gratuluji, instalace byla dokoncena.
Jeste zbyva doplnit radek 

vyroci -1

do vaseho souboru .profile (nebo .cshrc nebo .bashrc nebo janevimjak),
ale s tim si uz musite poradit sami. 

Pokud pri pouzivani programu narazite na nejake chyby, 
nebo budete mit navrh, jak program vylepsit, nevahejte 
a poslete mi mail na adresu Michal Ludvig <michal@ludvig.cz>\n
");

	exit(0);
}
