#include <stdio.h>
#include <errno.h>
#include <string.h>

#include "mic.h"
#include "config.h"
#include "vyroci.h"

#define	debug		printf
#define	debug2	printf

int ProcessAnnual(void)
{
	FILE	*f;
	int	left,n,year,ret=0;
	char	name[200],buf[1000];
	int	nm,	/* nameday month */
			nd,	/* nameday day */
			na,	/* nameday attention */
			by,	/* birthday year */
			bm,	/* birthday month */
			bd,	/* birthday day */
			ba;	/* birthday attention */
	
	if((f=fopen(cfg.pannual,"r"))==NULL)
		fprintf(stderr,"varovani%c: Chtel jsem otevrit soubor '%s', ale nepovedlo se mi to (%s)\n",7,cfg.pannual,errstr(errno));
	else
	{
		while(!feof(f))
		{
			bzero(buf,1000);
			bzero(name,200);
			
			na=0;ba=0;
			bd=0;bm=0;by=0;nd=0;nm=0;
			
			fgets(buf,1000,f);
			
			if(buf[0]=='#' || buf[0]=='\n' || strchr(buf,'=')==NULL)
				continue;
			
			sscanf(buf,"%[^=]s ",name);
			
			if((n=strlen(name))==0)
				continue;
			
			while(name[--n]==' ')name[n]=0;
			
			n=sscanf(strchr(buf,'=')+1,"%d . %d . %d / %d",&bd,&bm,&by,&ba);
			
			if(n>=3)
			{
				if(ba==0)ba=cfg.andays;
				
				year=cfg.tdyear;
				
				if((left=AbsDay(year,bm,bd)-cfg.tdabs)==-cfg.tdabs)
					continue;
				
				if(left<0 && cfg.lastrun>left+cfg.tdabs)
					left=AbsDay(++year,bm,bd)-cfg.tdabs;
				
				if(left<=ba)
				{
					printf("%s %s %s %d. narozeniny%c\n",Str_vyroci1(left),left<0?"mel":"ma",name,year-by,left<=0?7:' ');
					ret++;
				}
			}
			
			if(strchr(buf,':')!=NULL)
				n=sscanf(strchr(buf,':')+1,"%d . %d . / %d",&nd,&nm,&na);
			
			if(n>2)
			{
				if(na==0)na=cfg.andays;
				
				year=cfg.tdyear;
				
				if((left=AbsDay(year,nm,nd)-cfg.tdabs)==-cfg.tdabs)
					continue;
				
				if(left<0 && cfg.lastrun>left+cfg.tdabs)
					left=AbsDay(++year,nm,nd)-cfg.tdabs;
				
				if(left<=na)
				{
					printf("%s %s svatek %s\n",Str_vyroci1(left),left<0?"mel":"ma",name);
					ret++;
				}
			}
		}
	}
	fclose(f);
	return ret;
}

