#include <stdio.h>
#include <errno.h>
#include <string.h>

#include "mic.h"
#include "config.h"
#include "vyroci.h"

#define	debug		printf
#define	debug2	printf

int ProcessNameday(void)
{
	FILE	*f;
	int	year,mon,day,left,ret=0;
	char	name[200],buf[1000];
	
	if((f=fopen(cfg.pnameday,"r"))==NULL)
		fprintf(stderr,"varovani%c: Chtel jsem otevrit soubor '%s', ale nejak se mi to nedari (%s)\n",7,cfg.pnameday,errstr(errno));
	else
	{
		while(!feof(f))
		{
			bzero(buf,1000);
			fgets(buf,1000,f);
			if(sscanf(buf,"%d.%d. = %[^\n]",&day,&mon,name)==3)
			{
				if((mon<cfg.tdmon)||(mon==cfg.tdmon && day<cfg.tdday))
					year=cfg.tdyear+1;
				else
					year=cfg.tdyear;
				
				if((left=AbsDay(year,mon,day))==0)
					continue;
				
				if((left-=cfg.tdabs)<cfg.nddays)
				{
					printf("%s ma svatek %s\n",Str_vyroci1(left),name);
					ret++;
				}
			}
		}
	}
	fclose(f);
	return ret;
}

